#ifdef HAVE_OPENSSL
#include <openssl/evp.h>
#include <openssl/md5.h>
#else
#include <gcrypt.h>
#endif

#include <syslog.h>
#include <zlib.h>

struct Packet {
    unsigned char *data;
    int len;
};
struct crypt {
    unsigned char *data;
    int len;
};
struct compression {
    unsigned char *data;
    int len;
};
struct keys {
    unsigned char key[18];
    unsigned char iv[18];
    char cipher[255];
#ifndef HAVE_OPENSSL
    char mode[25];
#endif
};
struct options {
    char host[255];
    int port_listen;
    int port_forward;
    int server;
    int daemon;
    int proto;
    int comp;
    struct keys key;
    char cipher[255];
#ifndef HAVE_OPENSSL
    char mode[25];
#endif
};
struct Network {
    struct sockaddr_in addr;
    int sockfd;
    socklen_t len;
};
struct Compress {
    z_stream zip;
    z_stream unzip;
};
#ifdef HAVE_OPENSSL
typedef EVP_CIPHER_CTX crypto_ctx;
#else
typedef gcry_cipher_hd_t crypto_ctx;
#endif

#define KEYFILE "/.passkey"
#define PACKET_SIZE  1024
